Remove DB queries from class of UnattendedController
Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Rails
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1201676 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3029
Description

UnattendedController makes DB queries for TemplateKinds in the class scope to define methods and set up action filters. This bad
style causes a problem in foreman_bootdisk which adds a method chain to the provision method in the class. When running tests
under Rails 4, if the controller's instantiated too early, the right methods aren't defined.

4) Error:
UnattendedControllerTest#test_0002_should get a kickstart even if not using the first NIC:
AbstractController::ActionNotFound: The action 'provision' could not be found for UnattendedContro
ller
test/functional/unattended_controller_test.rb:43:in “block in &lt;class:UnattendedControllerTe
st>"'

Changing this to make queries when it's called would create more testable code both in core and the plugin.

Related issues:

Related to Foreman - Refactor #13409: Remove maintain_test_schema! Rails init... Closed 01/27/2016
Related to Foreman - Bug #15490: CVE-2016-4995 - view_hosts permissions/filte... Closed 06/22/2016
Related to Foreman - Bug #10689: Unattended controller permission check does ... Duplicate 06/03/2015

Associated revisions

Revision b1997f52 - 01/12/2016 04:22 AM - Dominic Cleal
fixes #13039 - remove TemplateKind DB calls from UnattendedCtlr

UnattendedController created actions/methods during initialisation per
known TemplateKind, relying on the DB being populated. This caused
ordering issues when a plugin loaded the controller in a test
environment as the kinds weren't yet in the DB. The actions then were
not created.

The per-TemplateKind actions have been simplified to one fixed action
which is routed in the same way.

History

#1 - 01/07/2016 08:33 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3029 added

#2 - 01/12/2016 04:24 AM - Dominic Cleal

- translation missing: en.field_release set to 71

#3 - 01/12/2016 05:02 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100
Applied in changeset b1997f520137128b9f1939437c62c8c0543acb5c.
#4 - 01/27/2016 09:49 AM - Dominic Cleal
- Related to Refactor #13409: Remove maintain_test_schema! Rails initializer added

#5 - 06/22/2016 05:44 AM - Dominic Cleal
- Related to Bug #15490: CVE-2016-4995 - view_hosts permissions/filters not checked for provisioning template previews added

#6 - 06/22/2016 05:45 AM - Dominic Cleal

- Related to Bug #10689: Unattended controller permission check does not work added

#7 - 07/26/2016 12:21 PM - Bryan Kearney
- Bugzilla link set to 1201676
